From 6ca3800b1048e98c15f0b753d58265616b7df59a Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Jul 20 2016 21:20:45 +0000
Subject: [PATCH 559/1001] Add a library widget where someone can provide a list of links of interest


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 2e72e00..a365c3d 100755
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -4,6 +4,7 @@ from hubs.widgets import rules
 from hubs.widgets import sticky
 from hubs.widgets import about
 from hubs.widgets import badges
+from hubs.widgets import library
 from hubs.widgets import linechart
 from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
@@ -27,6 +28,7 @@ registry = {
     'sticky': sticky,
     'about': about,
     'badges': badges,
+    'library': library,
     'linechart': linechart,
     'fedmsgstats': fedmsgstats,
     'feed': feed,
diff --git a/hubs/widgets/library.py b/hubs/widgets/library.py
new file mode 100644
index 0000000..8f0dc4b
--- /dev/null
+++ b/hubs/widgets/library.py
@@ -0,0 +1,32 @@
+from hubs.hinting import hint, prefixed as _
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import argument
+from hubs.widgets import clean_input
+from hubs.widgets import templating
+
+import hubs.validators as validators
+
+chrome = panel("Library")
+template = templating.environment.get_template('templates/library.html')
+position = 'both'
+
+
+@argument(name="urls", default=None,
+          validator=validators.text,
+          help="A comma separated list of URLs to add to the library.")
+def data(session, widget, urls):
+    urls = [
+        clean_input.clean('<a href="{0}">{0}</a>'.format(u.strip()))
+        for u in widget.config.get('urls', '').split(',')
+        if u.strip()
+    ]
+    return dict(urls=urls)
+
+
+@hint(topics=[_('hubs.widget.update')])
+def should_invalidate(message, session, widget):
+    if not message['topic'].endswith('hubs.widget.update'):
+        return False
+    if message['msg']['widget']['id'] != widget.id:
+        return False
+    return True
